unit GIntData;

interface
uses Windows;

{ *********************************************************************************
  *                                                                               * 
  *    ,      . *
  *                                                                               *
  ********************************************************************************* }
const {     (.  EpochType) }
      epNone         = 0; {     }
      epFixed        = 1; {    }
      epCurrent      = 2; {      }
      epTrueCurrent  = 3; {      }

      {       (.  StdColors) }
      STDCOLORSCOUNT = 14;

      {     (    StdColors). }
      clSpace         = 0; {   () }
      clSpaceDaylight = 1; {   () }
      clHorizon       = 2; {  }
      clConBounds     = 3; {   }
      clConNames      = 4; {   }
      clStarImages    = 5; {   }
      clAdditionalObj = 6; {       }
      clConLines      = 7; {    }
      clDeepSkyObj    = 8; { , , .   .. }
      clGridLines     = 9; {    }
      clMoonUnlit     = 10;{      }
      clSun           = 11;{  }
      clCivilTwilight = 12;{   ( ) }
      clAstroTwilight = 13;{   ( ) }
                                                              
      { , ,        
         .       DrawSolarObjTypes }
      soSun  = $1;
      soMoon = $2;
      soMer  = $4;
      soVen  = $8;
      soMar  = $10;
      soJup  = $20;
      soSat  = $40;
      soUra  = $80;
      soNep  = $100;
      soPlu  = $200;

      OBJECTNUM_ERROR = -1; {     .   
                              -   . }

type TColor = $80000000..$7FFFFFFF; {  }

     {     }
     TStdColorArray = array[0..STDCOLORSCOUNT-1] of TColor;
     PStdColorArray = ^TStdColorArray;

type TProjection = (PARALLEL, CONIC); {    }
     TViewMode = (QUICK, DETAILED); {    - ""  ""  }
     TAzimuthZeroPoint = (ZP_NORTH,ZP_SOUTH); {    -    }

     {             .
        ObjectNum -     (  ). }
     TSetObjectNum = procedure(ObjectNum :Integer); stdcall;

     {       .      ,
         -   ..,     ,  OBJECTNUM_ERROR }
     TGetObjectNum = function:Integer; stdcall;

     TZStrings = class;

{    **************************************************************************************
     *                                                                                    *
     *     .       *
     *  ,   .                                              *
     *                                                                                    *
     ************************************************************************************** }
     TObjectGroup = class
     public
        { **********************************************************************************
          *    .  ,       *
          *  ,      Init.          *
          *      .                                   *
          ********************************************************************************** }

        {   . ( 5 .) }
        ID :string; { ['DEFLT'] }
        {  . ( 30 .) }
        Description :string; { ['default'] }
        {   . ( 5 .) }
        Version :string; { ['undef'] }
        {     ""   }
        QuickView :Boolean; { [true] }
        {     ""   }
        DetailedView :Boolean; { [true] }
        {         .. }
        ObjectSelect :Boolean; { [true] }
        {   ,   . }
        EpochType :Word; { [epNone] }
        {  ,    (     J2000) }
        Epoch :Double; { [0.0] }

        {     ,  
          . (       .) }
        AdvancedInfoStrings :TZStrings; { [''] ( . ) }

        {    ,  .
          (  ,    ""   .) }
        AdvancedActionString :string; { [''] ( . ) }

        {      . }
        InternalOptions :Boolean; { [false] }

        {    ,  . (  ,
             "..."   .) }
        SearchDescrString :string; { [''] (  ) }

        {      ,   ,
                  
            .       . }
        SearchGroupID :string; { [=ID  ] }
        SearchRa,SearchDec :Double;

        { ,    .  
           .     . }
        ResourcesInited :Boolean;

        {    .     Init 
          InitResources.      .
              RecordCount   
          GetRecordCount.     RecordCount  . }
        RecordCount :Integer;

        { ******************************************************************
          *    .  . *
          *     OnRefreshParams              *
          ****************************************************************** }

        UT, {    (  ). }
        ET, {    (  ). }
        LST  :Double; {      . }
        Latitude, Longitude, TimeZone :Double; { ,    . }

        {         . }
        ImCentX, ImCentY, ImRadius :Integer;
        {      . ( y' = y * ImYScale ) }
        ImYScale :Double;
        {     . (100% -  , ,  .) }
        Zoom :Integer;
        {    }
        Projection :TProjection;
        {      . }
        RotAngle :Double;
        {     -    }
        AzimuthZeroPoint :TAzimuthZeroPoint;
        {    }
        MirrorView :Boolean;

        {        (.  clXXXXX). }
        StdColors :TStdColorArray;

        {          .
          0 -       
          1 -    
          2 -      . 
          3 -    , .  .  }
        SkyBackgroundChanges :Byte;

        {    ,     . }
        StdFontHeight :Integer;
        {    ,     . }
        MaxCharWidth :Integer;

        {   . }
        DrawStars :Boolean; {      }
        MaxStarMag :Integer; {   ,     *100 }
        MaxLabeledStarMag :Integer; {      *100 }
        MagLevelsCount :Integer; {      . }
        UseStarProperNames :Boolean; {      . }

        {     . }
        DrawSolarObj :Boolean; {       . }
        DrawSolarObjTypes :Word; {   soXXXXX. }
        AlwaysHighPrecision :Boolean; {     . }

        { ,     . }
        DrawConBounds, {   . }
        DrawConLines, {    . }
        DrawConNames, {   . }
        DrawDeepSkyObj :Boolean; {  ,   .. }

        { **********************************************************************
          *     .             *
          *     CalculateObjects, DrawObjects.    *
          * (         *
          *  ,     .)                    *
          ********************************************************************** }

        {        }
        DC :HDC;
        {    }
        ViewMode :TViewMode;
        {       . }
        MinX, MaxX, MinY, MaxY :Integer;
        {        .
          ,  EpochType<>epNone.     
              Ra=0, MaxRa>360. }
        MinRa, MaxRa, MinDec, MaxDec :Double;

        { **************************************************************************
          *    .    ,   *
          *    . , ,  *
          *    .                                              *
          ************************************************************************** }
        constructor Create;
        destructor Destroy; override;

        { *****************************************************************
          *  ,     . *
          ***************************************************************** }

        {  .  (*100)   ,   
            .     
          DrawSymbol  GetSymbolSize. }
        function MagToSymbolNum(V :Integer) :Integer;
        {         x  y. }
        function IsPointVisible(x,y :Integer) :Boolean;
        {       R }
        function IsRectVisible(const R :TRect) :Boolean;
        {          Ra  Dec. }
        function IsEqPointVisible(Ra,Dec :Double) :Boolean;
        {      "",    . }
        function IsEqRectVisible(OMinRa,OMinDec, OMaxRa,OMaxDec :Double) :Boolean;
        {       1  GetRecordCount }
        function ObjectNumValid(ObjectNum :Integer) :Boolean;

        { *******************************************************************
          * ,    .    *
          *    .      *
          *  ,      ,   *
          *      .             *
          ******************************************************************* }

        {      }
        procedure Init; virtual;

        {    (  ,    ..).
           true,    . }
        function InitResources(Parent :HWnd) :Boolean; virtual;

        {  ,   . }
        procedure FreeResources(Parent :HWnd); virtual;

        {    .       RecordCount }
        function GetRecordCount :Integer; virtual;

        {        .  
               . }
        procedure OnRefreshParams; virtual;

        {    .       
               SetObjectNum   - 
             ( 1  GetRecordCount). }
        procedure CalculateObjects(SetObjectNum :TSetObjectNum); virtual;

        {    .  ,  ,
             GetObjectNum. }
        procedure DrawObjects(GetObjectNum :TGetObjectNum); virtual;


        { ,     .    
           ,  false. }
        function GetObjectRect(ObjectNum :Integer; var Rect :TRect) :Boolean; virtual;

        {    .    
              ,        .
                    "" 
           ,  GetObjectRaDec   . }
        function GetObjectRaDec(ObjectNum :Integer; var Ra,Dec :Double) :Boolean; virtual;

        {   GetObjectRaDec.   -   
              ,     ,
            GetObjectRaDec    GetObjectXY. 
                   , 
                 .
             ,  GetObjectRaDec  GetObjectXY,   . }
        function GetObjectXY(ObjectNum :Integer; var x,y :Integer ) :Boolean; virtual;

        {      .   ,
            .      
            . (.  GetAnotherGroupInfo  GetAnotherGroupObject) }
        function GetObjectData(ObjectNum :Integer; var Buffer; BufferSize :Integer) :Integer; virtual;

        {  info       
          (.  DrawString). }
        procedure GetObjectStrings(ObjectNum :Integer; const info :TZStrings); virtual;

        {     ObjectNum. (    
           .)     
            "...". }
        function GetObjectName(ObjectNum :Integer) :string; virtual;

        {     .
          Parent      -     ;
          ObjectNum   -    ;
          FunctionNum -  .

            AdvancedInfo      
          AdvancedInfoStrings, ,     ,
              . }
        procedure AdvancedInfo(Parent :HWnd; ObjectNum, FunctionNum :Integer); virtual;

        {    .     .   
              OBJECTNUM_ERROR.
                ,     
               SearchGroupID, SearchRa  SearchDec.

          Parent -        .

           SelectObjectForSearch ,   SearchDescrString
           . }
        function SelectObjectForSearch(Parent :HWnd) :Integer; virtual;

        {    .  true,  
           .
          
          Parent -      .

           EditOptions ,   InternalOptions = true. }
        function EditOptions(Parent :HWnd) :Boolean; virtual;

        {  ,  ,  
            .  true    
          ( / ).
          
          Parent -    .

           AdvancedAction ,   AdvancedActionString
           . }
        function AdvancedAction(Parent :HWnd) :Boolean; virtual;
     end;

     {      }
     TZStrings = class
     protected
        SCount :Integer;
        S :string;
     public
        constructor Create;
        procedure Clear; {   }
        procedure Add(const newStr :string); {   }
        procedure AddSubstr(const newStr :string); {   ( 
                                                       }
        property Count :Integer read SCount; {     }
        property Str :string read S; {   ,   #0 }
     end;

{    StarCalc }
const StarCalcFileName = 'StarCalc.exe';

{ *****************************************************************************
  *                                                                           *
  *   ,     ,   *
  *       .                     *
  *     StarCalc.                               *                           *
  *                                                                           *
  ***************************************************************************** }

{  "  ->    " 
    . RaI,DecI    .  
  true,     . }
function QuickRaDecToXY(RaI,DecI :Integer; var x,y :Integer) :Boolean; stdcall;
   external StarCalcFileName name 'QuickRaDecToXY';

{  "  ->    " 
      . Ra,Dec   . 
   true,     . }
function RaDecToXY(Ra,Dec :Double; var x,y :Integer) :Boolean; stdcall;
   external StarCalcFileName name 'RaDecToXY';

{  "    ->  "
       . Ra,Dec   .
    true,      
   . }
function XYToRaDec(x,y :Integer; var Ra,Dec :Double) :Boolean; stdcall;
   external StarCalcFileName name 'XYToRaDec';

{   ,     
   QuickRaDecToXY, RaDecToXY  XYToRaDec.   
      ,    J2000. }
procedure SetEpoch(Epoch :Double; EpochType :Word); stdcall;
   external StarCalcFileName name 'SetEpoch';

const {       }
      tsNorm     = #1;  tsGreek     = #2;
      tsIndexOn  = #3;  tsIndexOff  = #4;
      tsItalicOn = #5;  tsItalicOff = #6;
      tsSmallOn  = #7;  tsSmallOff  = #8;
      tsAstro    = #9;
      tsBoldOn   = #10; tsBoldOff   = #11;

{     FormString,    X,Y 
    .     .  
  Show=false,      -   
  .

    :

      "----"   :

     tsGreek + 'a' + tsNorm + tsIndexOn + '1' + tsIndexOff + ' '

     (     DrawString      PChar.)
}
function DrawString(FormString :PChar; X,Y :Integer; Show :Boolean) :Integer; stdcall;
   external StarCalcFileName name 'DrawString';

{   ,    DrawSymbol  GetSymbolSize.
    1  25    . }
const smComet         = 25; {     }
      smStarCluster   = 26; {      }
      smNebula        = 27; {     }
      smAsterisk      = 28; {    "" }

{     .     .
  SNum  -  .         V 
           MagToSymbolNum;
  X,Y   -     ;
  Color -  . }
procedure DrawSymbol(SNum :Integer; X,Y :Integer; Color :TColor); stdcall;
   external StarCalcFileName name 'DrawSymbol';

{        SNum }
procedure GetSymbolSize(SNum :Integer; var Width,Height :Integer); stdcall;
   external StarCalcFileName name 'GetSymbolSize';

{     SetDrawColor }
const atPen = 1;
      atFont = 2;
      atBrush = 3;

{   Pen, Font  Brush    .
       . }
function SetDrawColor(AttrType :Integer; Color :TColor):TColor; stdcall;
   external StarCalcFileName name 'SetDrawColor';

{ *      ,     * }

const { ,      : }
      rsDontSett = 1; {   }
      rsDontRise = 2; {   }
      rsSett     = 4; {  }
      rsRise     = 8; {  }

{      ,   .
  J      -   (  );
  Ra,Dec - .     J (  ). }
type TGetRaDec = procedure(J :Double; var Ra,Dec :Double); stdcall;

     {   ,   ..  }
     TRiseSettData = packed record
        RiseTime, SettTime :Double; {  ,   }
        TransitTime, TransitLTime :Double; {      }
        rsFlags :Integer; {   rsXXXXX (    ) }
     end;
     PRiseSettData = ^TRiseSettData;

{   ,   .
  
  Min_Alt   -       ,  
                ;
  Epoch     -   ,    GetRaDec (
               ,    J2000);
  GetRaDec  -  ,    .
  Data      -    TRiseSettData,    
              .   = nil,    .
  rsStrings -   ,      
                ,       .
                = nil,     .
  MaxCount  -   rsString. ,  rsStrings=nil. }
function CalcRiseSettTime(Min_Alt,Epoch :Double; GetRaDec :TGetRaDec;
   Data :PRiseSettData; rsStrings :PChar; MaxCount :Integer) :Integer; stdcall;
   external StarCalcFileName name 'CalcRiseSettTime';

{ ,  . ,    ,   ,
       ,    . }
procedure ShowRiseSettDialog(Min_Alt,Epoch :Double; GetRaDec :TGetRaDec); stdcall;
   external StarCalcFileName name 'ShowRiseSettDialog';

{ *        ,     * }


{ *         * }
const WP_GRIDS = 0; {       }

type TGridsParam = packed record
        Dr_AzLines :Boolean; {       }
        Dr_HorzLines :Boolean; {       }
        Dr_RaLines :Boolean; {    .    }
        Dr_DecLines :Boolean; {       }

        AzLinesStep :Integer; {       }
        HorzLinesStep :Integer; {       }
        RaLinesStep :Integer; {    .    }
        DecLinesStep :Integer; {       }

        AzimuthAuto :Boolean; {      
                                    }
        EquatAuto :Boolean;  {      
                                    }
        AzimuthGrid :Boolean; {     }
        EquatGrid :Boolean; {     }
     end;

{   Buffer     ParamType ( WP_XXXXX).
  BufferSize -  .  true,    . }
function GetAdditionalParam(ParamType :Integer; var Buffer; BufferSize :Integer) :Boolean; stdcall;
   external StarCalcFileName name 'GetAdditionalParam';

{   .
  Recalculate -   
  GroupID     -   ,    .
                 GroupID=nil,     ,
                 Recalculate=false,  GroupID . }
procedure RefreshSkyImage(Recalculate :Boolean; GroupID :PChar); stdcall;
   external StarCalcFileName name 'RefreshSkyImage';


{  Buffer       'x.xx l',  l - ,
     ('R' - , 'E' - ).
    ,   Buffer. }
function GetStarCalcVersion(var Buffer; BufferSize :Integer) :Integer; stdcall;
   external StarCalcFileName name 'GetStarCalcVersion';

{   ,  GetStarCalcVersion     
  .     StarCalcVersion  StarCalcLanguage. }
var StarCalcVersion :array[1..7] of char;
    StarCalcLanguage :char;

{   Value   ValueName   Section
    StarCalc }
procedure SaveIniString(Section, ValueName, Value :PChar); stdcall;
   external StarCalcFileName name 'SaveIniString';

{  Buffer     ValueName   Section
    StarCalc.    . }
function RestoreIniString(Section, ValueName, DefaulValue :PChar; var Buffer; BufferSize :Integer) :Integer; stdcall;
   external StarCalcFileName name 'RestoreIniString';

{           .
     ,   Win32API GetDeviceCaps(DC, BITSPIXEL). }
function GetDrawDeviceBitDepth:Integer; stdcall;
   external StarCalcFileName name 'GetDrawDeviceBitDepth';


{ ***********************************************************
  *         *
  *********************************************************** }

{    }
const
      {    sccFlags }
      ciInternalOptions = $1; {      }
      ciAdvancedInfo = $2; {      }
      ciReserved = $4;
      ciAdvancedAction = $80; {    ,
                                       }
      ciObjSelect = $8; {        }
      ciObjSearch = $10; {     }

      ciQuickView = $20; {     }
      ciDetailedView = $40; {     }

type TGroupID = array[1..6] of char; {   }

     TGroupInfo = packed record
        GroupID :TGroupID; { 1-5    }
        Description :array[1..31] of char; { 30-   }
        Version :array[1..6] of char; {   }
        RecordCount :Integer; {   () }
        EpochType :Word; {      }
        Epoch :Double; {   . ,  EpochType = epFixed }
        sccFlags :Word; {   ci*****    }
        Init :Boolean; { true,    }
     end;

{         GroupID }
function GetAnotherGroupInfo(GroupID :PChar; var GroupInfo :TGroupInfo) :Boolean; stdcall;
   external StarCalcFileName name 'GetAnotherGroupInfo';

{        ObjNum  
    GroupID.   ,   .  }
function GetAnotherGroupObject(GroupID :PChar; ObjNum :Integer;
                               var Buffer; BufferSize :Integer) :Integer; stdcall;
   external StarCalcFileName name 'GetAnotherGroupObject';

{    ,   /  
  (  "gexports.pas".    TObjectGroup  .) }
type PCommonParameters = ^TCommonParameters;
     TCommonParameters = packed record
        {      MJD: ,      }
        UT, ET, LST  :Double;

        {  : , ,   }
        Latitude, Longitude, TimeZone :Double;

        {   :}
        {   ,  }
        ImCentX, ImCentY, ImRadius :Integer;
        {       (y'=y*ImYScale) }
        ImYScale :Double;
        {    (100% -     ) }
        Zoom :Integer;
        {    -    }
        Projection :TProjection;
        {      .  0  . }
        RotAngle :Double;
        {     -    }
        AzimuthZeroPoint :TAzimuthZeroPoint;
        { true,    -  }
        MirrorView :Boolean;

        {    StarCalc     }
        StdColors :PStdColorArray;
        {          :
          0 -       
          1 -    
          2 -      . 
          3 -    , .  .  }
        SkyBackgroundChanges :Byte;

        {    StarCalc   }
        StdFontHeight :Integer;
        {       StarCalc }
        MaxCharWidth :Integer;

        { : }
        {      }
        DrawStars :Boolean;
        {     -  ,   100 }
        MaxStarMag :Integer;
        {   ,   -  ,   100 }
        MaxLabeledStarMag :Integer;
        {            }
        MagLevelsCount :Integer;
        {       }
        UseStarProperNames :Boolean;

        {   : }
        {        }
        DrawSolarObj :Boolean;
        {        .   soXXXX}
        DrawSolarObjTypes :Word;
        {          }
        AlwaysHighPrecision :Boolean;

        {       : }
        {  ;   ;  ; , ., .   }
        DrawConBounds, DrawConLines, DrawConNames, DrawDeepSkyObj :Boolean;
     end;

implementation

constructor TObjectGroup.Create;
begin
   ID                   := 'DEFLT';
   Description          := 'default';
   Version              := 'undef';
   RecordCount          := 0;
   QuickView            := true;
   DetailedView         := true;
   ObjectSelect         := true;
   EpochType            := epNone;
   Epoch                := 0;
   SearchDescrString    := '';
   AdvancedInfoStrings  := TZStrings.Create;
   AdvancedActionString := '';
   InternalOptions      := false;
   ResourcesInited      := false;
   SearchGroupID        := '';

   Init;
end;

destructor TObjectGroup.Destroy;
begin
   if ResourcesInited then FreeResources(0);
   AdvancedInfoStrings.Free;
end;

function TObjectGroup.MagToSymbolNum(V :Integer) :Integer;
var MSV :Integer;
begin
   MSV := MaxStarMag + 150;
   if MSV<=0 then
      Result := 1
   else begin
      Result := MagLevelsCount - ((V+150) * (MagLevelsCount-1) + MSV shr 1) div MSV;
      if Result<1 then
         Result:=1
      else
         if Result>MagLevelsCount then
            Result:=MagLevelsCount
   end
end;

function TObjectGroup.IsPointVisible(x,y :Integer) :Boolean;
begin
   Result := (x>=MinX) and (x<=MaxX) and (y>=MinY) and (y<=MaxY);
end;

function TObjectGroup.IsRectVisible(const R :TRect) :Boolean;
begin
   with R do Result := not( (Left>MaxX) or (Right<MinX) or (Top>MaxY) or (Bottom<MinY) );
end;

function TObjectGroup.IsEqPointVisible(Ra,Dec :Double) :Boolean;
begin
   Result := false;
   if (Dec>=MinDec) and (Dec<=MaxDec) then begin
      Result := (Ra>=MinRa ) and (Ra<=MaxRa );
      if (not Result) and (MaxRa>360.0) then
         Result := (Ra+360.0>=MinRa ) and (Ra+360.0<=MaxRa)
   end;
end;

function TObjectGroup.IsEqRectVisible(OMinRa,OMinDec, OMaxRa,OMaxDec :Double) :Boolean;
begin
   Result := false;
   if (OMinDec>MaxDec) or (OMaxDec<MinDec) then Exit;
   if (MaxRa>360) and (OMinRa<MaxRa-360) then begin
      OMinRa := OMinRa + 360;
      OMaxRa := OMaxRa + 360;
   end;
   Result := not( (OMinRa>MaxRa) or (OMaxRa<MinRa) );
end;

function TObjectGroup.ObjectNumValid(ObjectNum :Integer) :Boolean;
begin
   Result := (ObjectNum>0) and (ObjectNum<=GetRecordCount);
end;

procedure TObjectGroup.CalculateObjects(SetObjectNum :TSetObjectNum);
begin
end;

procedure TObjectGroup.DrawObjects(GetObjectNum :TGetObjectNum);
begin
end;

function TObjectGroup.GetObjectRect(ObjectNum :Integer; var Rect :TRect) :Boolean;
begin
   Result := false;
end;

function TObjectGroup.GetObjectRaDec(ObjectNum :Integer; var Ra,Dec :Double) :Boolean;
begin
   Result := false;
end;

function TObjectGroup.GetObjectXY(ObjectNum :Integer; var x,y :Integer ) :Boolean;
begin
   Result := false;
end;

function TObjectGroup.GetObjectData(ObjectNum :Integer; var Buffer; BufferSize :Integer) :Integer;
begin
   Result := 0;
end;

procedure TObjectGroup.GetObjectStrings(ObjectNum :Integer; const info :TZStrings);
begin
end;

function TObjectGroup.GetObjectName(ObjectNum :Integer) :string;
begin
   Result := '';
end;

procedure TObjectGroup.AdvancedInfo(Parent :HWnd; ObjectNum, FunctionNum :Integer);
begin
end;

function TObjectGroup.SelectObjectForSearch(Parent :HWnd) :Integer;
begin
   Result := OBJECTNUM_ERROR;
end;

function TObjectGroup.EditOptions(Parent :HWnd) :Boolean;
begin
   Result := false;
end;

function TObjectGroup.AdvancedAction(Parent :HWnd) :Boolean;
begin
   Result := false;
end;

procedure TObjectGroup.Init;
begin
end;

function TObjectGroup.InitResources(Parent :HWnd) :Boolean;
begin
   Result := true;
   ResourcesInited := true;
end;

procedure TObjectGroup.FreeResources(Parent :HWnd);
begin
   ResourcesInited := false;
end;

function TObjectGroup.GetRecordCount :Integer;
begin
   Result := RecordCount;
end;

procedure TObjectGroup.OnRefreshParams;
begin
end;

constructor TZStrings.Create;
begin
   Clear;
end;

procedure TZStrings.Clear;
begin
   S := '';
   SCount := 0;
end;

procedure TZStrings.Add(const newStr :string);
begin
   AddSubstr(newStr);
   S := S + #0;
   Inc(SCount);
end;

procedure TZStrings.AddSubstr(const newStr :string);
var i :Integer;
begin
   for i:=1 to Length(newStr) do if newStr[i]=#0 then Inc(SCount);
   S := S + newStr;
end;

initialization
   StarCalcLanguage := StarCalcVersion[GetStarCalcVersion(StarCalcVersion, 7)];
end.
