unit CoordCnv;

interface

{ *****************************************************************************
  *                                                                           * 
  *      .                                *
  *                                                                           *
  *   StarCalc   ,      *
  *      (   *
  *     ,   ..),              *
  *  , ,           *
  *     .                      *
  *                                                                           *
  *                 *
  * ,    J2000. ( T = (JD-2451545.0)/36525.0 )        *                   *
  *                                                                           *
  ***************************************************************************** }

type Real33 = Array[1..3,1..3] Of double; {   3x3,   
                                                
                                            . }

const {      }
      J1875 :Double = -1.2499657768;
      J1900 :Double = -0.9999726215;
      B1950 :Double = -0.500002108;
      J1975 :Double = -0.2499931554;
      J2000 :Double =  0.0;

{      }
procedure Cart(R,Theta,Phi :Double; var X,Y,Z :Double); stdcall;

{      }
procedure Polar(X,Y,Z :Double; var R,Theta,Phi :Double); stdcall;

{        T. }
function GetEps(T :Double) :Double; stdcall;

{     . }
procedure EclEqu(T :Double; var X,Y,Z :Double); stdcall;

{     . }
procedure EquEcl(T :Double; var X,Y,Z :Double); stdcall;

{    A[i,j]   
     T1  T2. }
procedure PMatEqu(T1,T2 :Double; var A :Real33); stdcall;

{    A[i,j]   
     T1  T2. }
procedure PMatEcl(T1,T2 :Double; var A :Real33); stdcall;

{      A[i,j]    
  . (   PMatEqu  PMatEcl.) }
procedure Precart(A :Real33; var X,Y,Z :Double); stdcall;

{        
  ( > 0.1"  MAC 1980). }
procedure NutEqu(T :Double; var X,Y,Z :Double); stdcall;

{   . ,  NutEqu,    -
     ,   . }
procedure PMatNutEqu(T :Double; var A :Real33); stdcall;

{      .
  LST -       
  gRa,gDec -      
  gR -     
  Latitude -  
  tRa,tDec -  
           }
function Parallax(LST, gRa,gDec,gR, Latitude :Double; var tRa,tDec :Double) :Double; stdcall;

{     ,    alt  
  .
  atpress -   
  attemp -     }
function refrac(alt :Double; atpress,attemp :Double) :Double; stdcall;

{        .  <1".
  RaI,DecI     -     
  PMRaI,PMDecI -       
                   
  k            -    PMRaI, PMDecI,   10 .
                 (,  PMRaI  PMDecI   
                   ,  k -  ,   
                  RaI,DecI,   10.)
  mRaI,mDecI   - :       
                  . }
procedure PropMotion_LowPrec(RaI,DecI, PMRaI,PMDecI :Integer; k :Integer; var mRaI,mDecI :Integer); stdcall;

{        .
  Ra,Dec       -    
  PMRa,PMDec   -       
  k            -    PMRa, PMDec.
                 (,  PMRa  PMDec   
                   ,  k -  ,   
                  Ra,Dec.)
  mRa,mDec     - :         }
procedure PropMotion_HighPrec(Ra,Dec, PMRa,PMDec, k :Double; var mRa,mDec :Double); stdcall;

{    ,    ObjectEpoch 
      CurrEpoch   , ,  
   .. }
procedure AstrometricToApparent(ObjectEpoch, CurrEpoch :Double; var Ra,Dec :Double); stdcall;

implementation

const SCUtilDLL = 'SCUTILS.DLL';

procedure Cart(R,Theta,Phi :Double; var X,Y,Z:Double); external SCUtilDLL name 'Cart';
procedure Polar(X,Y,Z :Double; var R,Theta,Phi :Double); external SCUtilDLL name 'Polar';
function GetEps(T :Double) :Double; external SCUtilDLL name 'GetEps';
procedure EclEqu(T :Double; var X,Y,Z :Double); external SCUtilDLL name 'EclEqu';
procedure EquEcl(T :Double; var X,Y,Z :Double); external SCUtilDLL name 'EquEcl';
function Parallax(LST, gRa,gDec,gR, Latitude :Double; var tRa,tDec :Double) :double; external SCUtilDLL name 'Parallax';
function refrac(alt :double; atpress,attemp :Double) :Double; external SCUtilDLL name 'refrac';

procedure PMatEqu(T1,T2 :Double; var A :Real33); external SCUtilDLL name 'PMatEqu';
procedure PMatEcl(T1,T2 :Double; var A :Real33); external SCUtilDLL name 'PMatEcl';
procedure Precart(A :Real33; var X,Y,Z :Double); external SCUtilDLL name 'Precart';
procedure NutEqu(T :Double; var X,Y,Z :Double); external SCUtilDLL name 'NutEqu';
procedure PMatNutEqu(T :Double; var A :Real33); external SCUtilDLL name 'PMatNutEqu';

procedure PropMotion_LowPrec(RaI,DecI, PMRaI,PMDecI :Integer; k :Integer; var mRaI,mDecI :Integer); external SCUtilDLL name 'PropMotion_LowPrec';
procedure PropMotion_HighPrec(Ra,Dec, PMRa,PMDec, k :Double; var mRa,mDec :Double); external SCUtilDLL name 'PropMotion_HighPrec';
procedure AstrometricToApparent(ObjectEpoch, CurrEpoch :Double; var Ra,Dec :Double); external SCUtilDLL name 'AstrometricToApparent';

end.